if lca==nil then lca={} end
lca.ranhealgun={}
lca.ranhealgun.ray={}

lca.ranhealgun.gfx_wpn=loadgfx("weapons/randomhealgun.png")
setmidhandle(lca.ranhealgun.gfx_wpn)
lca.ranhealgun.gfx_pro=loadgfx("weapons/lasershot.png")
setmidhandle(lca.ranhealgun.gfx_pro)
lca.ranhealgun.sfx_attack=loadsfx("laser.wav")
lca.ranhealgun.sfx_impact=loadsfx("laserimpact.wav")

lca.ranhealgun.id=addweapon("lca.ranhealgun","Radnom Heal Gun",lca.ranhealgun.gfx_wpn,2,1)
lca.ranhealgun.ammo=1


function lca.ranhealgun.draw()
	setblend(blend_alpha)
	setalpha(1)
	setcolor(255,255,255)
	drawinhand(lca.ranhealgun.gfx_wpn,6,0)
	if lca.ranhealgun.ammo-weapon_shots>0 then
		hudammobar(lca.ranhealgun.ammo-weapon_shots,lca.ranhealgun.ammo)
	end
	if lca.ranhealgun.ammo-weapon_shots>0 then
		hudcrosshair(7,3)
	end
end

function lca.ranhealgun.attack(attack)
	if weapon_timer>0 then
		weapon_timer=weapon_timer-1
	end
	if weapon_shots<lca.ranhealgun.ammo and weapon_timer<=0 and attack==1 then
		useweapon(0)
		weapon_timer=15
		playsound(lca.ranhealgun.sfx_attack)
		weapon_shots=weapon_shots+1
		id=createprojectile(lca.ranhealgun.ray.id)
		projectiles[id]={}
		projectiles[id].ignore=playercurrent()
		projectiles[id].x=getplayerx(0)+(7*getplayerdirection(0))-math.sin(math.rad(getplayerrotation(0)))*5.0
		projectiles[id].y=getplayery(0)+3+math.cos(math.rad(getplayerrotation(0)))*5.0
		projectiles[id].sx=math.sin(math.rad(getplayerrotation(0)))*15.0
		projectiles[id].sy=-math.cos(math.rad(getplayerrotation(0)))*15.0
		projectiles[id].timer=0
		projectiles[id].x=projectiles[id].x-projectiles[id].sx*1.5
		projectiles[id].y=projectiles[id].y-projectiles[id].sy*1.5
		for i=1,3,1 do
			if lca.ranhealgun.ray.move(id)==1 then
				break
			end
		end
		recoil(3)
		particle(p_muzzle,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*12,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*12)
		particlecolor(1+math.random(0,254),1+math.random(0,254),1+math.random(0,254))
		particlefadealpha(0.01)
		particle(p_smoke,getplayerx(0)+(getplayerdirection(0)*7)+math.sin(math.rad(getplayerrotation(0)))*12,getplayery(0)+3-math.cos(math.rad(getplayerrotation(0)))*12)
		particlespeed(-0.2+math.random()*0.4+getwind()*10.0,-1.0+math.random()*0.6)
		particlefadealpha(0.005)
		if (weapon_shots>=lca.ranhealgun.ammo) then
			endturn()
		end
	end
end

lca.ranhealgun.ray.id=addprojectile("lca.ranhealgun.ray")

function lca.ranhealgun.ray.draw(id)
	setblend(blend_light)
	setalpha(1)
	setcolor(1+math.random(0,255),1+math.random(0,255),1+math.random(0,255))
	setscale(0.5,1)
	setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
	drawimage(lca.ranhealgun.gfx_pro,projectiles[id].x,projectiles[id].y)
	outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function lca.ranhealgun.ray.update(id)
	lca.ranhealgun.ray.move(id)
end

function lca.ranhealgun.ray.move(id)
	projectiles[id].timer=projectiles[id].timer+1
	if projectiles[id].timer>500 then
		freeprojectile(id)
		return 1
	end
	rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
	msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
	msubx=projectiles[id].sx/msubt
	msuby=projectiles[id].sy/msubt
	for i=1,msubt,1 do
		projectiles[id].x=projectiles[id].x+msubx
		projectiles[id].y=projectiles[id].y+msuby
		if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20,1,1)==1 then
			if terraincollision()==1 or playercollision()~=projectiles[id].ignore then
				if playercollision()~=0 then
				playerheal(playercollision(),random(1,100))
				end
				terraincircle(projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21,7,0x00000000)
				playsound(lca.ranhealgun.sfx_impact)
				particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
				particlefadealpha(0.006)
				particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
				particlecolor(1+math.random(0,254),1+math.random(0,254),1+math.random(0,254))
				particlefadealpha(0.01)
				freeprojectile(id)
				return 1
			end
		else
			projectiles[id].ignore=0
		end
		if (projectiles[id].y)>getwatery()+5 then
			playsound(lca.ranhealgun.sfx_impact)
			particle(p_smoke,projectiles[id].x,projectiles[id].y)
			freeprojectile(id)
			return 1
		end
	end
end